LOCAL_PATH := $(call my-dir)

#########################################################################
# Build ecryptfs_stat
#
include $(CLEAR_VARS)

ecryptfs_stat_src_files := \
    ecryptfs-stat.c

ecryptfs_stat_c_includes := \
    external/ecryptfs-utils/src/include

ecryptfs_stat_cflags := -O2 -g -W -Wall \
    -DHAVE_UNISTD_H \
    -DHAVE_ERRNO_H \
    -DHAVE_NETINET_IN_H \
    -DHAVE_SYS_IOCTL_H \
    -DHAVE_SYS_MMAN_H \
    -DHAVE_SYS_MOUNT_H \
    -DHAVE_SYS_PRCTL_H \
    -DHAVE_SYS_RESOURCE_H \
    -DHAVE_SYS_SELECT_H \
    -DHAVE_SYS_STAT_H \
    -DHAVE_SYS_TYPES_H \
    -DHAVE_STDLIB_H \
    -DHAVE_STRCASECMP \
    -DHAVE_STRDUP \
    -DHAVE_MMAP \
    -DHAVE_UTIME_H \
    -DHAVE_GETPAGESIZE \
    -DHAVE_LSEEK64 \
    -DHAVE_LSEEK64_PROTOTYPE \
    -DHAVE_LINUX_FD_H \
    -DHAVE_TYPE_SSIZE_T \
    -DHAVE_GETOPT_H \
    -DHAVE_SYS_TIME_H \
    -DHAVE_SYS_PARAM_H \
    -DHAVE_SYSCONF \
    -DHAVE_TERMIO_H

ecryptfs_stat_shared_libraries := \
    libecryptfs_stat


ecryptfs_stat_system_shared_libraries := libc

include $(CLEAR_VARS)

LOCAL_SRC_FILES := $(ecryptfs_stat_src_files)
LOCAL_C_INCLUDES := $(ecryptfs_stat_c_includes)
LOCAL_CFLAGS := $(ecryptfs_stat_cflags)
LOCAL_SHARED_LIBRARIES := $(ecryptfs_stat_shared_libraries)
LOCAL_SYSTEM_SHARED_LIBRARIES := $(ecryptfs_stat_system_shared_libraries)
LOCAL_MODULE := ecryptfs_stat
LOCAL_MODULE_TAGS := optional

include $(BUILD_EXECUTABLE)

#########################################################################
# Build ecryptfs_stat_dir
#

include $(CLEAR_VARS)

LOCAL_SRC_FILES := ecryptfs-stat-dir.c
LOCAL_C_INCLUDES := $(ecryptfs_stat_c_includes)
LOCAL_CFLAGS := $(ecryptfs_stat_cflags)
LOCAL_SHARED_LIBRARIES := $(ecryptfs_stat_shared_libraries) libcutils
LOCAL_SYSTEM_SHARED_LIBRARIES := $(ecryptfs_stat_system_shared_libraries)
LOCAL_MODULE := ecryptfs_stat_dir
LOCAL_MODULE_TAGS := optional

include $(BUILD_EXECUTABLE)

#########################################################################
# Build ecryptfs_rewrite
#

include $(CLEAR_VARS)

LOCAL_SRC_FILES := ecryptfs-rewrite.c
LOCAL_C_INCLUDES := system/core/logwrapper/include 
#LOCAL_CFLAGS := $(ecryptfs_stat_cflags)
LOCAL_STATIC_LIBRARIES := liblogwrap 
LOCAL_SHARED_LIBRARIES := liblog libcutils
#LOCAL_SYSTEM_SHARED_LIBRARIES := $(ecryptfs_stat_system_shared_libraries)
LOCAL_MODULE := ecryptfs_rewrite
LOCAL_MODULE_TAGS := optional

include $(BUILD_EXECUTABLE)

#########################################################################
# Build rewrite script
#
include $(CLEAR_VARS)
LOCAL_MODULE       := ecryptfs-rewrite-file.sh
LOCAL_MODULE_TAGS  := optional
LOCAL_MODULE_CLASS := ETC
LOCAL_SRC_FILES    := ecryptfs-rewrite-file.sh
include $(BUILD_PREBUILT)

#########################################################################
# Build rewrite script
#
include $(CLEAR_VARS)
LOCAL_MODULE       := ecryptfs-decrypt-allfiles.sh
LOCAL_MODULE_TAGS  := optional
LOCAL_MODULE_CLASS := ETC
LOCAL_SRC_FILES    := ecryptfs-decrypt-allfiles.sh
include $(BUILD_PREBUILT)

