#include <android/log.h>
#include <stdio.h>
#include <string.h>
#include <dirent.h>
#include <fcntl.h>
#include <logwrap/logwrap.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>

#define LOG_TAG "rewrite"
#define ALOGE(...)  __android_log_print(ANDROID_LOG_ERROR, LOG_TAG, __VA_ARGS__)

static const char* kEcryptRewrite = "/system/etc/ecryptfs-rewrite-file";

static void runRewriteScript(const char* filename) {

    const char *args[4];
    int num_args;
    int status;
    int rc = -1;

        if (filename == NULL) {
        ALOGE("Invalid argument. dirname is null.");
                return;
        }

        if (access(kEcryptRewrite, X_OK)) {
        ALOGE("%s file not found.",kEcryptRewrite);
                return;
        }

    args[0] = "sh";
    args[1] = kEcryptRewrite;
    args[2] = filename;
    num_args = 3;

    rc = android_fork_execvp(num_args, (char **)args, &status, false, true);

    if (rc != 0) {
        ALOGE("Fail reencrypt.");
    }
}

int doRewriteAllFile(const char* dirname)
{
    struct dirent *de;
    int fd;
    DIR *d, *d2;
    int rc = 0;

    d = opendir(dirname);
    ALOGE("opendir..");
    while((de = readdir(d))) {
            if (de->d_name[0] == '.')
                    continue;

    char name[1024];
    strcpy(name, dirname);
    strcat(name, "/");
    strcat(name, de->d_name);

    if (de->d_type == DT_DIR)
            {
#if 0
                        printf("dir %s\n",de->d_name);
                        fd = openat(dfd, de->d_name, O_RDONLY | O_DIRECTORY);
                        if(fd < 0)
                                continue;

                        d2 = fdopendir(fd);
                        if(d2 == 0)
                                close(fd);
                        else {
                                rc = doRewriteAllFile(d2);
                                closedir(d2);
                                if (rc == 0) {
                                        return rc;
                                }
                        }
#endif
        doRewriteAllFile(name);
            } else if (de->d_type == DT_REG) {
                    printf("file %s\n",name);
                    // fd = openat(dfd, de->d_name, O_RDONLY);
                    runRewriteScript(name);
            }
    }
    return rc;
}


int main(int argc, const char *argv[]) {

    const char *dirname;
    struct stat sb;
    int fd = -1;
    int rc = 0;

    ALOGE("rewrite script start.");

    if (argc == 1) {
        ALOGE("argument is short.");
        return -1;
    }

    dirname = argv[1];
    rc = stat(dirname, &sb);

    if (rc == 0) {
        if (S_ISREG(sb.st_mode)) {
            ALOGE("run script %s",dirname);
            runRewriteScript(dirname);
        } else if (S_ISDIR(sb.st_mode)) {
            ALOGE("dir call doRewriteAllFile %s",dirname);
            // DIR *d = opendir(dirname);
            doRewriteAllFile(dirname);
        }

    } else {
        ALOGE("%s does not exist.", dirname);
        return -1;
    }

    return 0;
}
